/*----------------------------------------------------------------------------
 Author:         Sebastian Voitzsch
 Version:        08.03.2014
 Description:	 HomeMatic device (actor with button, one channel for now...)
------------------------------------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include <compat/deprecated.h>
//#define F_CPU 128000UL		// 128kHZ
#define F_CPU 1000000UL		// 8 MHz
#include <util/delay.h>
#include "usart.h"
#include "rf22.h"

#define OUT_PORT PORTA		// port for output (LED)
#define OUT_P PA1		// pin for LED (PA1)
#define OUT_DDR DDRA
#define OUT_PIN PINA
//#define NIRQ_PORT PORTA
//#define NIRQ_PIN PINA
//#define NIRQ_DDR DDRA
//#define NIRQ_P PA2
#define IN_PORT PINA
#define SPI_PORT PORTA
#define SPI_DDR DDRA
#define SPI_PIN PINA
#define SPI_MOSI PA6
#define SPI_MISO PA5
#define SPI_SCK PA4
#define RF22_CS PA3
#define BUTTON_PORT PORTA
#define BUTTON_DDR DDRA
#define BUTTON_PIN PINA
#define BUTTON_P PA0

#define BUTTON_SHORT 1
#define BUTTON_LONG 2
#define MSG_RECEIVED 4
#define IRQ_WAKEUP 8

#define HM_ID1 0xf3
#define HM_ID2 0x92
#define HM_ID3 0xde

unsigned char ccu_id[3];	// PROGMEM = {0x42, 0x42, 0x42};
const unsigned char dev_info[18] PROGMEM = {
	0x11,							// 1 - firmware version
	0x00, 0x6c,						// 2 - model id, i.e. hardware descriptor
	'P','S','0','0','0','0','0','0','0','2',		// 10 - serial number for pairing/identification
	0x9f,							// 1 - subtype (?)
	0x10, 0x41, 0x01,					// 3 - number of channels etc.
	0x03};							// 1 - number of retries before missing ACK

const unsigned char reg_bank_0[7] PROGMEM = {			// channel 0 register bank
	0x02, 0x0a, 0x00, 0x0b, 0x00, 0x0c, 0x00 };
unsigned char eeCCUID1 EEMEM;				// eeprom space for CCU ID
unsigned char eeCCUID2 EEMEM;
unsigned char eeCCUID3 EEMEM;
unsigned char eeActStatus EEMEM;				// and for actuator status

typedef struct {
        uint8_t length;
        uint8_t counter;
	uint8_t flag;
        uint8_t type;
        uint8_t source[3];
        uint8_t destination[3];
        uint8_t payload[30];
	uint8_t status[2];						// rssi, crc etc.
} hm_message;

hm_message hm_msg;

//unsigned char *x_ptr= (unsigned char *) &rx_msg;			// define char pointer to struct variable
//unsigned char rxtx_buf[64];						// buffer for io

uint8_t white_key, carry, rec_flag, rec_type, rec_length, config, reg_bank;
volatile char cmd, timer, counter;					// communication with timer irq: button pressed, long pressed or recv?
