/*----------------------------------------------------------------------------
 Copyright:
 Author:
 Remarks:
 known Problems: none
 Version:        16.12.2009
 Description:    RF22 Funkmodule
------------------------------------------------------------------------------*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <compat/deprecated.h>

#define F_CPU 8000000UL
#include <util/delay.h>

#define BAND_868

#define RF22_PORT PORTA
#define RF22_DDR  DDRA
#define RF22_PIN  PINA

#define NIRQ_PORT PORTA
#define NIRQ_PIN PINA
#define NIRQ_DDR DDRA

#define CS		3
#define DI		6
#define DO		5
#define SCK		4
#define NIRQ_P		2

#define CONF_LEN 0x79
#define MAX_PKT_SIZE 42

void rf22_init(void);											// initialize module
void rf22_setfreq(unsigned short freq);

void rf22_write(unsigned char addr, unsigned char data);
unsigned char rf22_read(unsigned char addr);

void rf22_rxmode(void);

unsigned char rf22_getpacket(unsigned char *data);
void rf22_sendpacket(unsigned char *data);
void get_next_key(uint8_t *key, uint8_t *carry);
uint16_t calc_CRC (uint8_t *rtxbuf, uint8_t length);

#ifdef BAND_868
 #define RF22FREQ(freq)	((freq-860.0)*3200)
#else
 #define RF22FREQ(freq)	((freq-430.0)*6400)
#endif


